<template>
    <div id="app">
        <main class="home">
            <AppHeader :scrolled="false" :scrollHandler="true">
                <AppMenu/>
                <AppLangSelect hidden/>
            </AppHeader>
            <Artwork/>
            <Solutions/>
            <PlansPrices ref="planPrices"/>
            <MoreHelp/>
            <PlansComparison/>
            <Guaranties/>
            <Testimonials/>
            <ContactUs/>
        </main>
        <AppFooter :mt="180"/>
    </div>
</template>

<script>
    import AppHeader from "@/components/AppHeader";
    import AppMenu from "@/components/AppMenu";
    import AppLangSelect from "@/components/AppLangSelect";
    import Artwork from "./partials/Artwork";
    import Solutions from "./partials/Solutions";
    import PlansPrices from "./partials/PlansPrices";
    import MoreHelp from "./partials/MoreHelp";
    import PlansComparison from "./partials/PlansComparison";
    import Guaranties from "./partials/Guaranties";
    import Testimonials from "./partials/Testimonials";
    import ContactUs from "./partials/ContactUs";
    import AppFooter from "@/components/AppFooter";
    import SpecialOffer from "../components/SpecialOffer";
    import {mapGetters} from "vuex";

    export default {
        name: "Home",
        components: {
            AppHeader,
            AppMenu,
            AppLangSelect,
            Artwork,
            Solutions,
            PlansPrices,
            MoreHelp,
            PlansComparison,
            Guaranties,
            Testimonials,
            ContactUs,
            AppFooter
        },
        methods: {
            beforeClose() {
                if (this.timeoutOffer) {
                    clearTimeout(this.timeoutOffer);
                }
            },
            handleScroll() {
                if (this.$refs.planPrices.$el.offsetTop <= window.scrollY) {
                    window.removeEventListener("scroll", this.handleScroll);
                    if (!this.timeoutOffer) {
                        const timeout = setTimeout(() => {
                            this.$modal.show(SpecialOffer, null, {
                                name: 'offer',
                                scrollable: true,
                                adaptive: true,
                                width: '998px',
                                height: 'auto',
                                'before-close': this.beforeClose()
                            });
                            clearTimeout(timeout);
                            this.$store.dispatch('setTimeoutOffer', null);
                        }, 10000);
                        this.$store.dispatch('setTimeoutOffer', timeout);
                    }
                }
            }
        },
        computed: {
            ...mapGetters([
                'timeoutOffer'
            ])
        },
        mounted() {
            window.addEventListener("scroll", this.handleScroll);
        },
        destroyed() {
            window.removeEventListener("scroll", this.handleScroll);
        }
    };
</script>

<style lang="scss">
    * {
        outline: none;
    }

    .home {
        padding-top: 145px;
    }
    
    .section-title {
        color: #0f0f0f;
        font-family: $mainFont, sans-serif;
        font-size: 36px;
        font-weight: 700;
        letter-spacing: 0.8px;
        text-align: center;

        &.left {
            text-align: left;
        }
    }
</style>
